<?php
/**************************************************
  Coppermine 1.5.x Plugin - pixcomment
**************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

global $CONFIG, $lang_plugin_pixcomment;
require_once "./plugins/pixcomment/init.inc.php";

//--Define plugin actions here
$thisplugin->add_action('plugin_install','pixcomment_install');
$thisplugin->add_action('plugin_uninstall','pixcomment_uninstall');
$thisplugin->add_action('page_start', 'pixcomment_page_start');

//--Define plugin filters here
$thisplugin->add_filter('admin_menu','pixcomment_config_button');

if ($CONFIG['plugin_pixcomment_disable'] == 0) {

if ($CONFIG['plugin_pixcomment_position'] == 1) {
$thisplugin->add_filter('html_image','image_created');
} else {
$thisplugin->add_filter('theme_img_navbar','image_created');
}

$thisplugin->add_filter('page_html', 'pixcomment_page_html');
$thisplugin->add_filter('page_meta','style_for_header');
}


//--Define the plugin's installation here
function pixcomment_install() {
    global $CONFIG;
	// Add the config options for the plugin
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_pixcomment_disable', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_pixcomment_position', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_pixcomment_multiline', '0')");
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('pixcomment_config_button', '1')");		
    return true;
}

//--Define the plugin's uninstallation here
function pixcomment_uninstall() {
    global $CONFIG, $lang_errors;
	$superCage = Inspekt::makeSuperCage();
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    // Delete the plugin config records
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_pixcomment_disable'");
	  cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_pixcomment_position'");
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_pixcomment_multiline'");
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'pixcomment_config_button'");
    return true;
}

//--Page start with multiline editor
function pixcomment_page_start() {

global $CONFIG;

//If multiline editor enabled...
if  ($CONFIG['plugin_pixcomment_multiline'] == 1)
{
    global $template_add_your_comment, $lang_plugin_pixcomment;
    
$template_add_your_comment = <<<EOT
        <form method="post" name="post" id="post" action="db_input.php">
                <table align="center" width="{WIDTH}" cellspacing="1" cellpadding="0" class="maintable">
                        <tr>
                                        <td width="100%" class="tableh2">{ADD_YOUR_COMMENT}{HELP_ICON}</td>
                        </tr>
                        <tr>
                <td colspan="1">
                        <table width="100%" cellpadding="0" cellspacing="0">

<!-- BEGIN user_name_input -->
                                                        <tr>
                               <td class="tableb tableb_alternate">
                                        {NAME}
                                </td>
                                <td class="tableb tableb_alternate">
                                        <input type="text" class="textinput" name="msg_author" size="10" maxlength="20" value="{USER_NAME}" onclick="if (this.value == '{DEFAULT_USERNAME}') this.value = '';" onkeyup="if (this.value == '{DEFAULT_USERNAME}') this.value = '';" />
                                </td>
<!-- END user_name_input -->
<!-- BEGIN input_box_smilies -->
                                <td class="tableb tableb_alternate">
                                {COMMENT}
                                </td>
                                <td width="100%" class="tableb tableb_alternate">
                                <textarea class="textinput" id="message" name="msg_body" onselect="storeCaret_post(this);" onclick="storeCaret_post(this);" onkeyup="storeCaret_post(this);" maxlength="{MAX_COM_LENGTH}" style="width: 100%;" rows="4"></textarea>
                                </td>
<!-- END input_box_smilies -->
<!-- BEGIN input_box_no_smilies -->
                                <td class="tableb tableb_alternate">
                                {COMMENT}
                                </td>
                                <td width="100%" class="tableb tableb_alternate">
                                <textarea class="textinput" id="message" name="msg_body"  maxlength="{MAX_COM_LENGTH}" style="width: 100%;" rows="4"></textarea>
                                </td>
<!-- END input_box_no_smilies -->
<!-- BEGIN submit -->
                                <td class="tableb tableb_alternate">
                                <input type="hidden" name="event" value="comment" />
                                <input type="hidden" name="pid" value="{PIC_ID}" />
                                <button type="submit" class="button" name="submit" value="{OK}"  onclick="return notDefaultUsername(this.form, '{DEFAULT_USERNAME}', '{DEFAULT_USERNAME_MESSAGE}');">{OK_ICON}{OK}</button>
                                <input type="hidden" name="form_token" value="{FORM_TOKEN}" />
                                <input type="hidden" name="timestamp" value="{TIMESTAMP}" />
                                </td>
<!-- END submit -->
                                                        </tr>
<!-- BEGIN comment_captcha -->
                                                        <tr>
                                <td class="tableb tableb_alternate" colspan="2">
                                  {CONFIRM}
                                </td>
                                <td class="tableb tableb_alternate" colspan="2">
                                  <input type="text" name="confirmCode" size="5" maxlength="5" class="textinput" />
                                  <img src="captcha.php" align="middle" border="0" alt="" />
                                </td>
                                                        </tr>
<!-- END comment_captcha -->
                        </table>
                </td>
        </tr>
<!-- BEGIN smilies -->
        <tr>
                <td width="100%" class="tableb tableb_alternate">
                        {SMILIES}
                </td>
        </tr>
<!-- END smilies -->
<!-- BEGIN login_to_comment -->
        <tr>
                                <td class="tableb tableb_alternate" colspan="2">
                                  {LOGIN_TO_COMMENT}
                                </td>
        </tr>
<!-- END login_to_comment -->
                </table>
        </form>
EOT;
}

}

//--Config button for admin menu
function pixcomment_config_button($admin_menu){
    global $CONFIG, $lang_plugin_pixcomment;

    if ($CONFIG['pixcomment_config_button'] == 1) {
	    $new_button = '<li><a href="index.php?file=pixcomment/admin"';
	    $new_button .= ' title="' . $lang_plugin_pixcomment['config_button_title'] . '">';
	    $new_button .= $lang_plugin_pixcomment['config_button'] . '</a></li>';
	    $look_for = '<!-- END documentation -->'; // This is where you determine the place in the admin menu
	    $admin_menu = str_replace($look_for, $look_for . $new_button, $admin_menu);
    }
    return $admin_menu;
}




//--Add a filter for the gallery header on image page only	
function style_for_header($html) {

if (defined('DISPLAYIMAGE_PHP')) {
  global $CONFIG, $template_header;

  $superCage = Inspekt::makeSuperCage();

$pixcomment_meta = <<< EOT
<link rel="stylesheet" href="plugins/pixcomment/style.css" type="text/css" media="screen" /> 
EOT;

$javapath = <<< EOT
<script type="text/javascript" src="plugins/pixcomment/pixcomment.js"></script>    
EOT;
      
$html = $javapath ."\n". $pixcomment_meta . $html;
  }
return $html;

}   


//--Show comments
function image_created($html) {
	global  $CURRENT_PIC_DATA, $CONFIG, $CPG_PHP_SELF, $lang_plugin_pixcomment;

  $superCage = Inspekt::makeSuperCage(); 
  $picid = $CURRENT_PIC_DATA['pid'];
  $caption = $CURRENT_PIC_DATA['caption'];
  $title = $CURRENT_PIC_DATA['title'];
  $home = $CONFIG['site_url'];
  $path = $home.$CPG_PHP_SELF."?pid=".$picid;
 
  //If get comment id, show only this comment
  if ($superCage->get->keyExists('commid'))
  {
    $commid = $superCage->get->getInt('commid');
    $addonquery = 'AND msg_id = '.$commid;
  } else {
    $addonquery = "";
  }
  
  
  //Query with filter id too if have this
  $result = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_COMMENTS']} WHERE approval = 'YES' AND pid = {$picid} {$addonquery}");   
  mysql_data_seek($result,0);
  $sorok = (mysql_num_rows($result))-1;

  
  //build array with id, author, comment body
  $i=0;
  while ($row = mysql_fetch_array($result)){
  $hszid[$i] = $i;
  $msg_id[$i] = $row['msg_id'];
  $msg_author[$i] = $row['msg_author'];
  $msg_body[$i] = bb_decode(process_smilies($row['msg_body'])); 
  $i++; 
  }
  
  //randomize comments  
  $commazon = rand (0,$sorok);
  $comm_body = $msg_body[$commazon];
  $comm_author = $msg_author[$commazon];
  $commpath = $path."&commid=".$msg_id[$commazon];
        

//build comment if have comment to picture
if ($sorok >= 0) {  

$comment_div = <<< EOT
<table id="kommenttable" class="tableb tableb_alternate">
<tr id="kommentrow">
<td id="komment"><h2>"$comm_body"</h2><br />
<span class="komminfo"> - $comm_author -</span>
</td>
</tr>
</table>
<div id="hiddenrow" style="display:none">
<table id="hiddentable" class="tableb tableb_alternate">
<tr>
<td>{$lang_plugin_pixcomment['linktext']}</td>
<td id="kommpath"><input id="pathtext" name="pathtext" type="text" value="$commpath" size="70" title="{$lang_plugin_pixcomment['linktext_tip']}" /></td>
<td id="randombutton"><button type="button" class="button" id="kommbutton" onclick="window.location.href='{$path}'">{$lang_plugin_pixcomment['random']}</button></td>
</tr>
</table>
</div>
<p class="komm_showhide"><a href="javascript:showtable('hiddenrow');">{$lang_plugin_pixcomment['showhide']}</a></p>
EOT;
   
return $html.$comment_div;
} else {
return $html;
}
}


//--Comment link on comment header
function pixcomment_page_html($html) {
        global $CONFIG,$lang_plugin_pixcomment; 

    if (defined('DISPLAYIMAGE_PHP')) {        

        $superCage = Inspekt::makeSuperCage();
        $pid = $superCage->get->getInt('pid');
        $commurl = "\\0<span id=\"kommentlink\"><a href=\"{$CONFIG['site_url']}displayimage.php?pid={$pid}&amp;commid=\\1\" title=\"{$lang_plugin_pixcomment['kommentlink_title']}\">{$lang_plugin_pixcomment['kommentlink']}</a></span>";
        $html = preg_replace('/<table.*<a name="comment([0-9]+)"><\/a>.*<\/span>/Usi', $commurl, $html);
    }
    return $html;
}


?>